#!/usr/pkg/bin/perl

use Device::SerialPort;
use Time::HiRes qw( usleep );

my $line;
my $port = Device::SerialPort->new($ARGV[0]) or die "failed to open serial port";
$port->databits(8);
$port->baudrate(115200);
$port->parity("none");
$port->stopbits(1);

$port->write("*IDN?\n");
$line = getportln($port);
print ("IDN: $line\n");

my $setvolt=24;

$port->write(":FUNC CV\n");
setvolt($port, $setvolt);
$port->write(":INP ON\n");

while ($setvolt >= 10)
{
	setvolt($port, $setvolt);
	$setvolt = $setvolt - 0.1;
}
$port->write(":INP OFF\n");

exit(0);

sub setvolt
{
	my ($p, $v) = @_;
	$p->write(":VOLT " . $v . "V\n");
	$p->write(":VOLT?\n");
	my $l = getportln($p);
	print("set $l");
	usleep(500000);
	$p->write(":MEAS:CURR?\n");
	$l = getportln($p);
	print(" $l ");
	$p->write(":MEAS:VOLT?\n");
	$l = getportln($p);
	print(" $l\n");
}

sub getportln
{
	my ($p) = @_;
	my $l = "";
	while(1) {
		my $byte = $port->read(1);
		if ($byte eq "\n") {
			$p->lookclear;
			return $l;
		}
		$l = $l . $byte;
	}
}
